<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SalesRep StructType
 * @subpackage Structs
 */
class SalesRep extends AbstractStructBase
{
    /**
     * The IsInactive
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IsInactive;
    /**
     * The SalesRepInternalId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SalesRepInternalId;
    /**
     * The SalesRepId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SalesRepId;
    /**
     * The SalesRepType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SalesRepType;
    /**
     * The LinkedToInternalId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LinkedToInternalId;
    /**
     * The FirstName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FirstName;
    /**
     * The LastName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LastName;
    /**
     * The CompanyName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CompanyName;
    /**
     * The Phone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Phone;
    /**
     * The CellPhone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CellPhone;
    /**
     * The Fax
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Fax;
    /**
     * The Email
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Email;
    /**
     * The WebSite
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $WebSite;
    /**
     * The Address
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\StructType\Address
     */
    public $Address;
    /**
     * The AccountNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $AccountNumber;
    /**
     * The ExternalUniqueId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ExternalUniqueId;
    /**
     * The DateTimeCreated
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DateTimeCreated;
    /**
     * The DateTimeModified
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DateTimeModified;
    /**
     * Constructor method for SalesRep
     * @uses SalesRep::setIsInactive()
     * @uses SalesRep::setSalesRepInternalId()
     * @uses SalesRep::setSalesRepId()
     * @uses SalesRep::setSalesRepType()
     * @uses SalesRep::setLinkedToInternalId()
     * @uses SalesRep::setFirstName()
     * @uses SalesRep::setLastName()
     * @uses SalesRep::setCompanyName()
     * @uses SalesRep::setPhone()
     * @uses SalesRep::setCellPhone()
     * @uses SalesRep::setFax()
     * @uses SalesRep::setEmail()
     * @uses SalesRep::setWebSite()
     * @uses SalesRep::setAddress()
     * @uses SalesRep::setAccountNumber()
     * @uses SalesRep::setExternalUniqueId()
     * @uses SalesRep::setDateTimeCreated()
     * @uses SalesRep::setDateTimeModified()
     * @param bool $isInactive
     * @param string $salesRepInternalId
     * @param string $salesRepId
     * @param string $salesRepType
     * @param string $linkedToInternalId
     * @param string $firstName
     * @param string $lastName
     * @param string $companyName
     * @param string $phone
     * @param string $cellPhone
     * @param string $fax
     * @param string $email
     * @param string $webSite
     * @param \eBizCharge\StructType\Address $address
     * @param string $accountNumber
     * @param string $externalUniqueId
     * @param string $dateTimeCreated
     * @param string $dateTimeModified
     */
    public function __construct($isInactive = null, $salesRepInternalId = null, $salesRepId = null, $salesRepType = null, $linkedToInternalId = null, $firstName = null, $lastName = null, $companyName = null, $phone = null, $cellPhone = null, $fax = null, $email = null, $webSite = null, \eBizCharge\StructType\Address $address = null, $accountNumber = null, $externalUniqueId = null, $dateTimeCreated = null, $dateTimeModified = null)
    {
        $this
            ->setIsInactive($isInactive)
            ->setSalesRepInternalId($salesRepInternalId)
            ->setSalesRepId($salesRepId)
            ->setSalesRepType($salesRepType)
            ->setLinkedToInternalId($linkedToInternalId)
            ->setFirstName($firstName)
            ->setLastName($lastName)
            ->setCompanyName($companyName)
            ->setPhone($phone)
            ->setCellPhone($cellPhone)
            ->setFax($fax)
            ->setEmail($email)
            ->setWebSite($webSite)
            ->setAddress($address)
            ->setAccountNumber($accountNumber)
            ->setExternalUniqueId($externalUniqueId)
            ->setDateTimeCreated($dateTimeCreated)
            ->setDateTimeModified($dateTimeModified);
    }
    /**
     * Get IsInactive value
     * @return bool
     */
    public function getIsInactive()
    {
        return $this->IsInactive;
    }
    /**
     * Set IsInactive value
     * @param bool $isInactive
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setIsInactive($isInactive = null)
    {
        // validation for constraint: boolean
        if (!is_null($isInactive) && !is_bool($isInactive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isInactive, true), gettype($isInactive)), __LINE__);
        }
        $this->IsInactive = $isInactive;
        return $this;
    }
    /**
     * Get SalesRepInternalId value
     * @return string|null
     */
    public function getSalesRepInternalId()
    {
        return $this->SalesRepInternalId;
    }
    /**
     * Set SalesRepInternalId value
     * @param string $salesRepInternalId
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setSalesRepInternalId($salesRepInternalId = null)
    {
        // validation for constraint: string
        if (!is_null($salesRepInternalId) && !is_string($salesRepInternalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesRepInternalId, true), gettype($salesRepInternalId)), __LINE__);
        }
        $this->SalesRepInternalId = $salesRepInternalId;
        return $this;
    }
    /**
     * Get SalesRepId value
     * @return string|null
     */
    public function getSalesRepId()
    {
        return $this->SalesRepId;
    }
    /**
     * Set SalesRepId value
     * @param string $salesRepId
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setSalesRepId($salesRepId = null)
    {
        // validation for constraint: string
        if (!is_null($salesRepId) && !is_string($salesRepId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesRepId, true), gettype($salesRepId)), __LINE__);
        }
        $this->SalesRepId = $salesRepId;
        return $this;
    }
    /**
     * Get SalesRepType value
     * @return string|null
     */
    public function getSalesRepType()
    {
        return $this->SalesRepType;
    }
    /**
     * Set SalesRepType value
     * @param string $salesRepType
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setSalesRepType($salesRepType = null)
    {
        // validation for constraint: string
        if (!is_null($salesRepType) && !is_string($salesRepType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesRepType, true), gettype($salesRepType)), __LINE__);
        }
        $this->SalesRepType = $salesRepType;
        return $this;
    }
    /**
     * Get LinkedToInternalId value
     * @return string|null
     */
    public function getLinkedToInternalId()
    {
        return $this->LinkedToInternalId;
    }
    /**
     * Set LinkedToInternalId value
     * @param string $linkedToInternalId
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setLinkedToInternalId($linkedToInternalId = null)
    {
        // validation for constraint: string
        if (!is_null($linkedToInternalId) && !is_string($linkedToInternalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($linkedToInternalId, true), gettype($linkedToInternalId)), __LINE__);
        }
        $this->LinkedToInternalId = $linkedToInternalId;
        return $this;
    }
    /**
     * Get FirstName value
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->FirstName;
    }
    /**
     * Set FirstName value
     * @param string $firstName
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstName, true), gettype($firstName)), __LINE__);
        }
        $this->FirstName = $firstName;
        return $this;
    }
    /**
     * Get LastName value
     * @return string|null
     */
    public function getLastName()
    {
        return $this->LastName;
    }
    /**
     * Set LastName value
     * @param string $lastName
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setLastName($lastName = null)
    {
        // validation for constraint: string
        if (!is_null($lastName) && !is_string($lastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastName, true), gettype($lastName)), __LINE__);
        }
        $this->LastName = $lastName;
        return $this;
    }
    /**
     * Get CompanyName value
     * @return string|null
     */
    public function getCompanyName()
    {
        return $this->CompanyName;
    }
    /**
     * Set CompanyName value
     * @param string $companyName
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setCompanyName($companyName = null)
    {
        // validation for constraint: string
        if (!is_null($companyName) && !is_string($companyName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($companyName, true), gettype($companyName)), __LINE__);
        }
        $this->CompanyName = $companyName;
        return $this;
    }
    /**
     * Get Phone value
     * @return string|null
     */
    public function getPhone()
    {
        return $this->Phone;
    }
    /**
     * Set Phone value
     * @param string $phone
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setPhone($phone = null)
    {
        // validation for constraint: string
        if (!is_null($phone) && !is_string($phone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($phone, true), gettype($phone)), __LINE__);
        }
        $this->Phone = $phone;
        return $this;
    }
    /**
     * Get CellPhone value
     * @return string|null
     */
    public function getCellPhone()
    {
        return $this->CellPhone;
    }
    /**
     * Set CellPhone value
     * @param string $cellPhone
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setCellPhone($cellPhone = null)
    {
        // validation for constraint: string
        if (!is_null($cellPhone) && !is_string($cellPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cellPhone, true), gettype($cellPhone)), __LINE__);
        }
        $this->CellPhone = $cellPhone;
        return $this;
    }
    /**
     * Get Fax value
     * @return string|null
     */
    public function getFax()
    {
        return $this->Fax;
    }
    /**
     * Set Fax value
     * @param string $fax
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setFax($fax = null)
    {
        // validation for constraint: string
        if (!is_null($fax) && !is_string($fax)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fax, true), gettype($fax)), __LINE__);
        }
        $this->Fax = $fax;
        return $this;
    }
    /**
     * Get Email value
     * @return string|null
     */
    public function getEmail()
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @param string $email
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setEmail($email = null)
    {
        // validation for constraint: string
        if (!is_null($email) && !is_string($email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($email, true), gettype($email)), __LINE__);
        }
        $this->Email = $email;
        return $this;
    }
    /**
     * Get WebSite value
     * @return string|null
     */
    public function getWebSite()
    {
        return $this->WebSite;
    }
    /**
     * Set WebSite value
     * @param string $webSite
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setWebSite($webSite = null)
    {
        // validation for constraint: string
        if (!is_null($webSite) && !is_string($webSite)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($webSite, true), gettype($webSite)), __LINE__);
        }
        $this->WebSite = $webSite;
        return $this;
    }
    /**
     * Get Address value
     * @return \eBizCharge\StructType\Address|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param \eBizCharge\StructType\Address $address
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setAddress(\eBizCharge\StructType\Address $address = null)
    {
        $this->Address = $address;
        return $this;
    }
    /**
     * Get AccountNumber value
     * @return string|null
     */
    public function getAccountNumber()
    {
        return $this->AccountNumber;
    }
    /**
     * Set AccountNumber value
     * @param string $accountNumber
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setAccountNumber($accountNumber = null)
    {
        // validation for constraint: string
        if (!is_null($accountNumber) && !is_string($accountNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($accountNumber, true), gettype($accountNumber)), __LINE__);
        }
        $this->AccountNumber = $accountNumber;
        return $this;
    }
    /**
     * Get ExternalUniqueId value
     * @return string|null
     */
    public function getExternalUniqueId()
    {
        return $this->ExternalUniqueId;
    }
    /**
     * Set ExternalUniqueId value
     * @param string $externalUniqueId
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setExternalUniqueId($externalUniqueId = null)
    {
        // validation for constraint: string
        if (!is_null($externalUniqueId) && !is_string($externalUniqueId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalUniqueId, true), gettype($externalUniqueId)), __LINE__);
        }
        $this->ExternalUniqueId = $externalUniqueId;
        return $this;
    }
    /**
     * Get DateTimeCreated value
     * @return string|null
     */
    public function getDateTimeCreated()
    {
        return $this->DateTimeCreated;
    }
    /**
     * Set DateTimeCreated value
     * @param string $dateTimeCreated
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setDateTimeCreated($dateTimeCreated = null)
    {
        // validation for constraint: string
        if (!is_null($dateTimeCreated) && !is_string($dateTimeCreated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateTimeCreated, true), gettype($dateTimeCreated)), __LINE__);
        }
        $this->DateTimeCreated = $dateTimeCreated;
        return $this;
    }
    /**
     * Get DateTimeModified value
     * @return string|null
     */
    public function getDateTimeModified()
    {
        return $this->DateTimeModified;
    }
    /**
     * Set DateTimeModified value
     * @param string $dateTimeModified
     * @return \eBizCharge\StructType\SalesRep
     */
    public function setDateTimeModified($dateTimeModified = null)
    {
        // validation for constraint: string
        if (!is_null($dateTimeModified) && !is_string($dateTimeModified)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateTimeModified, true), gettype($dateTimeModified)), __LINE__);
        }
        $this->DateTimeModified = $dateTimeModified;
        return $this;
    }
}
